@echo OFF

rem #############################################################################
rem #
rem #
rem #  @(#)14 1.3 tklm/ws/code/tklm.config/db/DB2ROSSetup.bat, TKLM-Install, tklmv3.tklm 8/11/14 06:35:24
rem # ===========================================================================
rem # Licensed Materials - Property of IBM
rem #
rem # 5724-T60 5608-A91
rem # (C) Copyright IBM Corp. 2016 All Rights Reserved
rem #
rem # US Government Users Restricted Rights - Use, duplication, or
rem # disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
rem #  ===========================================================================
rem # 
rem #############################################################################

:: Keep variables local
SETLOCAL
SET CUR_DIR=%~dp0
SET MASTERTYPE=
SET DB2_ADMIN=
SET DB2PASS=
SET DBNAME=
SET multimasterRole=
SET rc=0
SET outputfile=%SystemDrive%\sklm40properties\DB2ROSSetup.output
date /T >> %outputfile%
time /T >> %outputfile%
goto setup
   
:getHADRROS
	echo in task  getHADRROS >>  %outputfile%
	FOR /F "tokens=*" %%a in ('db2set DB2_HADR_ROS') do SET HADR_ROS_STATUS=%%a >>  %outputfile%
	set HADR_ROS_STATUS=%HADR_ROS_STATUS: =%
	echo HADR_ROS_STATUS="%HADR_ROS_STATUS%" >>  %outputfile%
	
	if not "%HADR_ROS_STATUS%"=="%ROS_VALUE%" (
		goto updateHADRROS
	) 
	goto end
	
:updateHADRROS	
	db2set DB2_HADR_ROS=%ROS_VALUE%
	db2set DB2_STANDBY_ISO=UR
	if "%multimasterRole%"=="STANDBY" (
		db2 deactivate db %DBNAME%  >>  %outputfile%
	)
	goto restartDB2HADR
	
	
:restartDB2HADR
	db2stop force  >>  %outputfile%
	db2start  >>  %outputfile%
	if "%multimasterRole%"=="STANDBY" (
		db2 start HADR on database %DBNAME% as %multimasterRole%  >>  %outputfile%
	)
	if "%multimasterRole%"=="PRIMARY" (
		db2 start HADR on database %DBNAME% as %multimasterRole%  >>  %outputfile%
	)
	goto end

:setup
if [%1]==[] goto usage
if [%2]==[] goto usage
if [%3]==[] goto usage
if [%4]==[] goto usage
if [%5]==[] goto usage
set DB2_ADMIN=%1
set DB2PASS=%2
set DBNAME=%3
set multimasterRole=%~4
set ROS_VALUE=%~5

if "%ROS_VALUE%"=="" (
	echo ROS_VALUE value not set.
	SET rc=1
	goto end
)

if not "%ROS_VALUE%"=="ON" (
	if not "%ROS_VALUE%"=="OFF" (
		echo ROS_VALUE must be either ON or OFF.
		SET rc=1
		goto end
	)
)

cd %CUR_DIR%
echo multimasterRole=%multimasterRole% >> %outputfile%
goto getHADRROS


:usage
  @echo echo "usage: C:\Program Files (x86)\IBM\DB2SKLMV40/bin/db2cmd.exe  /c  /w /i C:/sklm40properties/scripts/DB2ROSSetup.bat DB2_ADMIN DB2_PASS DBNAME HADR_ROLE ROS_VALUE
  @echo	where
  @echo	DB2_ADMIN is the Database Instance Owner specified during the install
  @echo	DB2_PASS is the password of the database instance owner
  @echo	DBNAME is the name of the database default is SKLMDB40
  @echo HADR_ROLE is either PRIMARY or STANDBY
  @echo ROS_VALUE is either ON or OFF
  @echo Warning : This action may restart database server
  SET rc=1
goto end

:end
SET MASTERTYPE=
SET DB2_ADMIN=
SET DB2PASS=
SET DBNAME=
SET multimasterRole=
echo return code=%rc%  
exit %rc% 