@echo OFF

rem #############################################################################
rem #
rem #
rem #  @(#)14 1.3 tklm/ws/code/tklm.config/db/FP3DB2Update.bat, TKLM-Install, tklmv3.tklm 8/11/14 06:35:24
rem # ===========================================================================
rem # Licensed Materials - Property of IBM
rem #
rem # 5724-T60 5608-A91
rem # (C) Copyright IBM Corp. 2016 All Rights Reserved
rem #
rem # US Government Users Restricted Rights - Use, duplication, or
rem # disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
rem #  ===========================================================================
rem # 
rem #############################################################################

:: Keep variables local
SETLOCAL
SET CUR_DIR=%~dp0
SET MASTERTYPE=
SET DB2_ADMIN=
SET DB2PASS=
SET DBNAME=
SET WAS_HOME=
SET multimasterRole=
SET rc=0
SET outputfile=%SystemDrive%\sklm40properties\DB2update.output
date /T >> %outputfile%
time /T >> %outputfile%
goto setup
   
:index
db2 CONNECT TO %DBNAME% USER %DB2_ADMIN% USING '%DB2PASS%' >> %outputfile%
db2 -td# -s -f  %SystemDrive%\sklm40properties\scripts\tklmsql-fp.db2 >>  %outputfile%
SET rc=%ERRORLEVEL%

if not "%rc%"=="0" (
	echo Error in database script execution >>  %outputfile%
	goto end
)

if "%rc%"=="0" (
	echo Database changes execution complete. >>  %outputfile%
)

goto end

:setup
if [%1]==[] goto usage
if [%2]==[] goto usage
if [%3]==[] goto usage
if [%4]==[] goto usage
set DB2_ADMIN=%1
set DB2PASS=%2
set DBNAME=%3
set WAS_HOME=%~4

echo WAS_HOME=%WAS_HOME% >> %outputfile%
echo SKLM Config path = "%WAS_HOME%/products/sklm/config/MMConfig.properties"  >> %outputfile% 

if "%WAS_HOME%"=="" (
	echo WAS_HOME value not set.
	SET rc=1
	goto end
)

if not exist "%WAS_HOME%/products/sklm/config/MMConfig.properties" (
	echo.
	echo Invalid WAS_HOME directory set to %WAS_HOME%.
	SET rc=1
	goto end	
)
cd %WAS_HOME%/products/sklm/config
for /f "tokens=1,2,3 delims==" %%a in (MMConfig.properties) do (
	if "%%a"=="multimasterRole" set multimasterRole=%%b
)
cd %CUR_DIR%
echo multimasterRole=%multimasterRole% >> %outputfile%

if not "%multimasterRole%"=="STANDBY" (
	echo executing database changes as role is not STANDBY >> %outputfile%
	echo goto index >>  %outputfile%
	goto index
) else (
	echo Skipping database changes as role is STANDBY >> %outputfile%
	set rc=0
	goto end
)

:usage
	 
  @echo echo "usage: C:\Program Files\IBM\DB2SKLMV40/bin/db2cmd.exe  /c  /w /i C:/sklm40properties/scripts/FP1DB2Update.bat DB2_ADMIN DB2_PASS DBNAME WAS_HOME
  @echo	where
  @echo	DB2_ADMIN is the Database Instance Owner specified during the install
  @echo	DB2_PASS is the password of the database instance owner
  @echo	DBNAME is the name of the database default is SKLMDB40
  @echo WAS_HOME is the path to WAS HOME folder.
  SET rc=1
goto end

:end
SET MASTERTYPE=
SET DB2_ADMIN=
SET DB2PASS=
SET DBNAME=
SET WAS_HOME=
SET multimasterRole=
echo return code=%rc%  
exit %rc% 