@echo OFF
REM
REM Licensed Materials-Property of IBM
REM (C)Copyright IBM Corp 2008
REM All rights reserved
REM US Government Users Restricted Rights
REM Use, duplication, or disclosure restricted
REM by GSA ADP Schedule Contract with IBM Corp
REM
REM  arg1 -  log  -   log file to be used by this script 
REM  arg2 -  instance  -  instance name (for example db2inst2) 
REM  arg3 -  dbname  -  database name
REM 
REM   Note:  The batch file
REM 	        must be run on the same machine where DB2 server is installed.
REM      should be called if the Tivoli Key Life Cycle Manager Installer fails
REM      after sucessful creation of database instance and database name
REM ----------------------------------------------------------------------------

setlocal

%~d0
cd %~p0

set LOG=%~s1
REM Set DB2INSTANCE environment variable 
set DB_INST=%2
set DB_NAME=%3
SET DB2INSTANCE=%DB_INST%


REM Logging the header information in dbconfig.log file
echo ---------------------------------------------------------------------------------------------- >> "%LOG%" 
echo Started executing dbtklmrm.bat >> "%LOG%" 
echo ---------------------------------------------------------------------------------------------- >> "%LOG%" 

REM directory where scripts and response files have been written
set CURRENT_DIR=.




:DROP_DB
echo db2 connect reset >> "%LOG%"
db2 -l "%LOG%" "connect reset"
set IS_CONNECTED=0
REM Drop the database %DB_NAME%
echo "db2 drop database %DB_NAME%" >> "%LOG%"
db2 -l "%LOG%" "drop database %DB_NAME%"
set RC=%ERRORLEVEL%
                      
REM Cannot drop the instance till database is dropped.

if %RC% neq 0  echo The database %DB_NAME% could not be removed. Refer to the Tivoli Key Lifecycle Manager documentation for manually cleaning up the system.   >> "%LOG%"
if %RC% neq 0  goto END

:DROP_INST
echo "db2 stop database manager force" >> "%LOG%"
db2 stop database manager force
echo db2idrop -f %DB_INST% >> "%LOG%"
db2idrop -f %DB_INST%
set RC=%ERRORLEVEL%
if %RC% neq 0  echo The database instance %DB_INST% could not be removed. Refer to the Tivoli Key Lifecycle Manager documentation for manually cleaning up the system.   >> "%LOG%"
if %ERRORLEVEL% neq 0 set RC=%ERRORLEVEL%
db2 -l "%LOG%" "connect reset"

goto END


:PRINT_USAGE
echo "Usage: dbtklmrm.bat logfile dbinstance dbname" >> "%LOG% 
set RC=1
goto END

:END
if %RC%==0 echo Return=%RC% >> "%LOG%"
if %RC% neq 0 echo Return %RC% >> "%LOG%"

echo ---------------------------------------------------------------------------------------------- >> "%LOG%" 
exit %RC%
endlocal
