@echo off

SETLOCAL
 
SET CURR_DIR=%~dp0

:: Keep Local Variables
SET WAS_HOME=
SET DB_NAME=
SET DB_USERNAME=
SET DB_PASSWORD=
SET DB_PORT=
SET WAS_USER=
SET WAS_PASSWORD=

cd %CURR_DIR%

SET WAS_HOME=%~1
SET WAS_USER=%~2
SET WAS_PASSWORD=%~3
SET DB_NAME=%~4
SET DB_USERNAME=%~5
SET DB_PASSWORD=%~6
SET DB_PORT=%~7
SET SKLM_HOME=%~8

if "%WAS_HOME%"=="" (
echo WAS_HOME path value is invalid.
goto printUsage
)

if [%WAS_USER%]==[] (
echo WAS_USER value is invalid.
goto printUsage
)

if [%WAS_PASSWORD%]==[] (
echo WAS_PASSWORD value is invalid.
goto printUsage
)

if [%DB_NAME%]==[] (
echo DB_NAME value is invalid.
goto printUsage
)

if [%DB_USERNAME%]==[] (
echo DB_USERNAME value is invalid.
goto printUsage
)

if [%DB_PASSWORD%]==[] (
echo DB_PASSWORD value is invalid.
goto printUsage
)

if [%DB_PORT%]==[] (
echo DB_PORT value is invalid.
goto printUsage
)

if "%SKLM_HOME%"=="" (
echo SKLM_HOME value is invalid.
goto printUsage
)

goto validationSuccess

:printUsage
echo "Usage: addDBUserRepo.bat <WAS_HOME> <WAS_USER> <WAS_PASSWORD> <DB_NAME> <DB_USERNAME> <DB_PASSWORD> <DB_PORT> <SKLM_HOME>"
goto end 

:validationSuccess

echo Update realm settings
call "%WAS_HOME%/bin/wsadmin.bat" -username %WAS_USER% -password %WAS_PASSWORD% -lang jython -c "AdminTask.updateIdMgrRealm('[-name defaultWIMFileBasedRealm -allowOperationIfReposDown true]')"

call "%WAS_HOME%/bin/wsadmin.bat" -username %WAS_USER% -password %WAS_PASSWORD% -lang jython -f "%SKLM_HOME%\bin\LDAPIntegration\addDBUserRepo.py"  "%WAS_HOME%"  %DB_NAME% %DB_USERNAME%  %DB_PASSWORD% %DB_PORT%

echo Stopping server
call "%WAS_HOME%/bin/stopServer.bat" server1 -username %WAS_USER% -password %WAS_PASSWORD%

echo Starting server
call "%WAS_HOME%/bin/WASService.exe" -start SKLM40Server

echo Removing groups from file repository.
call "%WAS_HOME%/bin/wsadmin.bat" -user %WAS_USER% -password %WAS_PASSWORD% -lang jython -f "%SKLM_HOME%\bin\LDAPIntegration\removeGroupsFromDefRepos.py"

call "%WAS_HOME%/bin/wsadmin.bat" -user %WAS_USER% -password %WAS_PASSWORD% -lang jython -c "AdminApp.edit('sklm_kms', '[ -MapRolesToUsers [[ administrator AppDeploymentOption.No AppDeploymentOption.No \"\" \"\" AppDeploymentOption.No \"\" \"\" ]]]' )"

call "%WAS_HOME%/bin/wsadmin.bat" -user %WAS_USER% -password %WAS_PASSWORD% -lang jython -c "AdminConfig.save()"

rem echo Adding groups to database repository.
rem call "%WAS_HOME%/bin/wsadmin.bat" -user %WAS_USER% -password %WAS_PASSWORD% -lang jython -f "%SKLM_HOME%\bin\LDAPIntegration\addGroupsToDBRepos.py"

echo updating default settings
call "%WAS_HOME%/bin/wsadmin.bat" -username %WAS_USER% -password %WAS_PASSWORD% -lang jython -c "AdminTask.updateIdMgrSupportedEntityType('[-name PersonAccount -defaultParent \"o=sklmrepdb.ibm\" -rdnProperties uid]')"

call "%WAS_HOME%/bin/wsadmin.bat" -username %WAS_USER% -password %WAS_PASSWORD% -lang jython -c "AdminTask.updateIdMgrSupportedEntityType('[-name Group -defaultParent \"o=sklmrepdb.ibm\" -rdnProperties cn]')"

echo Saving settings..
call "%WAS_HOME%/bin/wsadmin.bat" -user %WAS_USER% -password %WAS_PASSWORD% -lang jython -c "AdminConfig.save()"


echo Remove SKLMAdmin user from realm admin role
call "%WAS_HOME%/bin/wsadmin.bat" -username %WAS_USER% -password %WAS_PASSWORD% -lang jython -c "AdminTask.removeUsersFromAdminRole('[-userids [SKLMAdmin ] -roleName klmSecurityOfficer]')"
call "%WAS_HOME%/bin/wsadmin.bat" -username %WAS_USER% -password %WAS_PASSWORD% -lang jython -c "AdminTask.removeUsersFromAdminRole('[-userids [SKLMAdmin ] -roleName suppressmonitor]')"

echo Remove SKLMAdmin user from users repo (File repo)
call "%WAS_HOME%/bin/wsadmin.bat" -username %WAS_USER% -password %WAS_PASSWORD% -lang jython -c "AdminTask.deleteUser ('[ -uniqueName \"uid=SKLMAdmin,o=defaultWIMFileBasedRealm\" ]')"

rem echo Add SKLMAdmin user 
rem call "%WAS_HOME%/bin/wsadmin.bat" -username %WAS_USER% -password %WAS_PASSWORD% -lang jython -c  "AdminTask.createUser ('[-uid SKLMAdmin -password SKLM@admin123 -confirmPassword SKLM@admin123 -cn key_lifecycle_manager_default_admin -sn key_lifecycle_manager_default_admin -parent \"o=sklmrepdb.ibm\"]')"

echo Adding user to group
rem call "%WAS_HOME%/bin/wsadmin.bat" -username %WAS_USER% -password %WAS_PASSWORD% -lang jython -c "AdminTask.addMemberToGroup ('[ -memberUniqueName \"uid=SKLMAdmin,o=sklmrepdb.ibm\"  -groupUniqueName  \"cn=klmSecurityOfficerGroup,o=sklmrepdb.ibm\"]')"
rem call "%WAS_HOME%/bin/wsadmin.bat" -username %WAS_USER% -password %WAS_PASSWORD% -lang jython -c "AdminTask.addMemberToGroup ('[ -memberUniqueName \"uid=SKLMAdmin,o=sklmrepdb.ibm\"  -groupUniqueName  \"cn=klmGUICLIAccessGroup,o=sklmrepdb.ibm\"]')"

rem echo Map SKLMAdmin user with admin role
rem call "%WAS_HOME%/bin/wsadmin.bat" -username %WAS_USER% -password %WAS_PASSWORD% -lang jython -c "AdminTask.mapUsersToAdminRole('[-accessids [user:defaultWIMFileBasedRealm/uid=SKLMAdmin,o=sklmrepdb.ibm ] -userids [SKLMAdmin ] -roleName klmSecurityOfficer]') "

rem call "%WAS_HOME%/bin/wsadmin.bat" -username %WAS_USER% -password %WAS_PASSWORD% -lang jython -c "AdminTask.mapUsersToAdminRole('[-accessids [user:defaultWIMFileBasedRealm/uid=SKLMAdmin,o=sklmrepdb.ibm ] -userids [SKLMAdmin ] -roleName suppressmonitor]')"

call "%WAS_HOME%/bin/wsadmin.bat" -user %WAS_USER% -password %WAS_PASSWORD% -lang jython -c "AdminApp.edit('sklm_kms', '[ -MapRolesToUsers [[ administrator AppDeploymentOption.No AppDeploymentOption.No \"\" klmGUICLIAccessGroup AppDeploymentOption.No \"\" group:defaultWIMFileBasedRealm/cn=klmGUICLIAccessGroup,o=sklmrepdb.ibm ]]]' )" 

echo Saving settings..
call "%WAS_HOME%/bin/wsadmin.bat" -user %WAS_USER% -password %WAS_PASSWORD% -lang jython -c "AdminConfig.save()"

echo Stopping server
call "%WAS_HOME%/bin/stopServer.bat" server1 -username %WAS_USER% -password %WAS_PASSWORD%

echo Starting server
call "%WAS_HOME%/bin/WASService.exe" -start SKLM40Server

:end
echo ending execution