@echo OFF
REM
REM Licensed Materials-Property of IBM
REM (C)Copyright IBM Corp 2009
REM All rights reserved
REM US Government Users Restricted Rights
REM Use, duplication, or disclosure restricted
REM by GSA ADP Schedule Contract with IBM Corp
REM
REM  arg1 -  log  -   log file to be used by this script 
REM  arg2 -  instance  -  instance name (for example db2inst2) 
REM  arg3 -  dbname  -  database name
REM  arg4 -  dbuserid  - database instance owner
REM  arg5 -  dbpassword  - database password
REM 
REM   Note:  The batch file
REM 	        must be run on the same machine where DB2 server is installed.
REM 		does not do parameter validation
REM 	  	will fail if the user specifies a wrong dbuserid or password

REM ----------------------------------------------------------------------------

setlocal

%~d0
cd %~p0

set LOG=%~s1
REM Set DB2INSTANCE environment variable 
set DB_INST=%2
set DB_NAME=%3
set DB_USERID=%4
set DB_PASSWORD=%5
set RC=0
SET DB2INSTANCE=%DB_INST%


REM Logging the header information in tklmupdsql.log file
echo ---------------------------------------------------------------------------------------------- >> "%LOG%" 
echo Started executing dbtklmpostmigration.bat >> "%LOG%" 
echo ---------------------------------------------------------------------------------------------- >> "%LOG%" 

REM directory where scripts and response files have been written
set CURRENT_DIR=.
set IS_CONNECTED=0


REM CREATE TABLES 
:RUNDDL
set RC=0
REM Database is created, now connect to database
echo "db2 start database manager" >> "%LOG%"
db2 start database manager
echo "db2 connect to %DB_NAME% USER %DB_USERID% USING *****" >> "%LOG%" 
db2 -l "%LOG%" "connect to %DB_NAME% USER %DB_USERID% USING '%DB_PASSWORD%'"
set RC=%ERRORLEVEL%
if %RC% LSS 0 goto ERROR
if %RC% LSS 3 set RC=0 
if not %RC%==0 goto ERROR
set IS_CONNECTED=1

REM Create new objects added in TKLM V2 
echo "db2 -s -t -f tklmpostmigration.db2" >> "%LOG%"
db2 -l "%LOG%" -s -t -f tklmpostmigration.db2"
set RC=%ERRORLEVEL%
if %RC% LSS 0 goto ROLLBACK
if %RC% LSS 3 set RC=0 
if not %RC%==0 goto ROLLBACK

REM Disconnect from database, no need to check for error code
if %IS_CONNECTED%==1 db2 -l "%LOG%" "connect reset"

:ROLLBACK
db2 rollback

goto END

:ERROR



goto END



:PRINT_USAGE
echo "Usage: dbpostmigration.bat logfile dbinstance dbname dbusername dbpassword" >> "%LOG% 
set RC=1
goto END

:END
db2 -l "%LOG%" "connect reset"
set IS_CONNECTED=0
if %RC%==0 echo Return=%RC%
if %RC% neq 0 echo Return %RC%
if %RC%==0 echo Return=%RC% >> "%LOG%"
if %RC% neq 0 echo Return %RC% >> "%LOG%"

echo ---------------------------------------------------------------------------------------------- >> "%LOG%" 
COPY /Y %LOG% ..
DEL /Q /F %LOG%

exit %RC%
endlocal
