@echo off
:: Keep variables local
SETLOCAL
SET WAS_HOME=
SET TKLM_TIP_HOME=
SET WAS_ADMIN_ID=
SET WAS_ADMIN_PASSWORD=
SET SKLM_INSTALL_PATH=
SET SKLM_ADMIN_USER=
SET SKLM_ADMIN_USER_PASSWORD=
SET MIG_LOG_PATH=
SET TKLM_VERSION=
SET TKLM_DB_PWD=
SET KEYSTORE_PWD=
SET IM_INSTALL_DIR=

if "%JAVA_HOME%"=="" (
 echo.
 echo JAVA_HOME Variable not set. Set the JAVA_HOME environment variable and try again.
 goto end
)

if not exist migration.properties goto noconfig

for /f "tokens=1,2,3 delims==" %%a in (migration.properties) do (
  
  if "%%a"=="WAS_HOME" set WAS_HOME=%%b
  if "%%a"=="TKLM_TIP_HOME" set TKLM_TIP_HOME=%%b
  if "%%a"=="WAS_ADMIN_ID" set WAS_ADMIN_ID=%%b
  if "%%a"=="WAS_ADMIN_PASSWORD" set WAS_ADMIN_PASSWORD=%%b
  if "%%a"=="SKLM_INSTALL_PATH" set SKLM_INSTALL_PATH=%%b
  if "%%a"=="SKLM_ADMIN_USER" set SKLM_ADMIN_USER=%%b
  if "%%a"=="SKLM_ADMIN_USER_PASSWORD" set SKLM_ADMIN_USER_PASSWORD=%%b
  if "%%a"=="MIG_LOG_PATH" set MIG_LOG_PATH=%%b
  if "%%a"=="TKLM_VERSION" set TKLM_VERSION=%%b
  if "%%a"=="TKLM_DB_PWD" set TKLM_DB_PWD=%%b
  if "%%a"=="KEYSTORE_PWD" set KEYSTORE_PWD=%%b
  if "%%a"=="IM_INSTALL_DIR" set IM_INSTALL_DIR=%%b
  )
  
if "%WAS_HOME%"=="" (
 echo.
 echo WAS_HOME Property is empty.
 goto end
)

if "%TKLM_TIP_HOME%"=="" (
 echo.
 echo TKLM_TIP_HOME Property is empty.
 goto end
)

if "%WAS_ADMIN_ID%"=="" (
 echo.
 echo WAS_ADMIN_ID Property is empty.
 goto end
)

if "%WAS_ADMIN_PASSWORD%"=="" (
 echo.
 echo WAS_ADMIN_PASSWORD Property is empty.
 goto end
)

if "%SKLM_INSTALL_PATH%"=="" (
 echo.
 echo SKLM_INSTALL_PATH Property is empty.
 goto end
)

if "%SKLM_ADMIN_USER%"=="" (
 echo.
 echo SKLM_ADMIN_USER Property is empty.
 goto end
)

if "%SKLM_ADMIN_USER_PASSWORD%"=="" (
 echo.
 echo SKLM_ADMIN_USER_PASSWORD Property is empty.
 goto end
)

if "%MIG_LOG_PATH%"=="" (
 echo.
 echo MIG_LOG_PATH Property is empty.
 goto end
)

if "%TKLM_VERSION%"=="" (
 echo.
 echo TKLM_VERSION Property is empty.
 goto end
)

if "%TKLM_DB_PWD%"=="" (
 echo.
 echo TKLM_DB_PWD Property is empty.
 goto end
)

if "%KEYSTORE_PWD%"=="" (
 echo.
 echo KEYSTORE_PWD Property is empty.
 goto end
)

if "%IM_INSTALL_DIR%"=="" (
 echo.
 echo IM_INSTALL_DIR Property is empty.
 goto end
)

goto run

:noconfig
@echo Cannot find migration.properties. The parameter values cannot be determined. Run this script again by specifying the following parameters in migration.properties
@echo WAS_HOME
@echo TKLM_TIP_HOME
@echo WAS_ADMIN_ID
@echo WAS_ADMIN_PASSWORD
@echo SKLM_INSTALL_PATH
@echo SKLM_ADMIN_USER
@echo SKLM_ADMIN_USER_PASSWORD
@echo IM_APP_DATA_DIR
@echo TKLM_VERSION
@echo TKLM_DB_PWD
@echo KEYSTORE_PWD
@echo IM_INSTALL_DIR
goto end
  
:run
rem call "%WAS_HOME%/bin/wsadmin.bat" -lang jython -profileName KLMProfile -username %WAS_ADMIN_ID% -password %WAS_ADMIN_PASSWORD% -f "%SKLM_INSTALL_PATH%/migration/bin/migrateUsers.py" "%TKLM_TIP_HOME%" "%WAS_HOME%" "%SKLM_ADMIN_USER%" "%MIG_LOG_PATH%" 0 
rem echo.
rem call "%WAS_HOME%/bin/wsadmin.bat" -lang jython -username %WAS_ADMIN_ID% -password %WAS_ADMIN_PASSWORD% -f "%SKLM_INSTALL_PATH%/migration/bin/migrateAddRolesandUsers2Roles.py" "%TKLM_TIP_HOME%" "%SKLM_INSTALL_PATH%" "%MIG_LOG_PATH%"
rem echo.
rem call "%WAS_HOME%/bin/wsadmin.bat" -lang jython -profileName KLMProfile -username %WAS_ADMIN_ID% -password %WAS_ADMIN_PASSWORD% -f "%SKLM_INSTALL_PATH%/migration/bin/migrateAddRolesandUsers2Roles2V25.py" "%WAS_HOME%" "%SKLM_INSTALL_PATH%" "%MIG_LOG_PATH%"
rem echo.
rem call "%WAS_HOME%/bin/wsadmin.bat" -lang jython -profileName KLMProfile -username %WAS_ADMIN_ID% -password %WAS_ADMIN_PASSWORD% -f "%SKLM_INSTALL_PATH%/migration/bin/migrateUsers.py" "%TKLM_TIP_HOME%" "%WAS_HOME%" "%SKLM_ADMIN_USER%" "%MIG_LOG_PATH%" 1
rem echo.
SET MIG_CP=%SKLM_INSTALL_PATH%/migration/com.ibm.sklm.migration.jar;%WAS_HOME%/universalDriver/lib/db2jcc.jar;%WAS_HOME%/lib/j2ee.jar;%WAS_HOME%/plugins/com.ibm.icu.jar;%WAS_HOME%/plugins/com.ibm.tklm.commands.jar;%WAS_HOME%/java/jre/lib/ext/ibmkeycert.jar;%WAS_HOME%/java/jre/lib/ext/ibmpkcs11impl.jar;%WAS_HOME%/java/jre/lib/ext/ibmjcefips.jar;
call :IM_CLASSPATH
"%JAVA_HOME%/bin/java.exe" -cp "%MIG_CP%" com.ibm.sklm.im.helper.SecretDataMigrationRunner %WAS_ADMIN_ID% %WAS_ADMIN_PASSWORD% %TKLM_DB_PWD% %KEYSTORE_PWD% %TKLM_VERSION% "%MIG_LOG_PATH%" "%TKLM_TIP_HOME%" "%WAS_HOME%" "%SKLM_INSTALL_PATH%" "%SKLM_ADMIN_USER%" "%SKLM_ADMIN_USER_PASSWORD%"

goto end

:IM_CLASSPATH
for %%i in ("%IM_INSTALL_DIR%\plugins\com.ibm.cic.common.core_*.jar") do call :SETCP %%i
for %%i in ("%IM_INSTALL_DIR%\plugins\org.eclipse.core.runtime_*.jar") do call :SETCP %%i
for %%i in ("%IM_INSTALL_DIR%\plugins\org.eclipse.osgi*.jar") do call :SETCP %%i
for %%i in ("%IM_INSTALL_DIR%\plugins\org.apache.commons*.jar") do call :SETCP %%i
for %%i in ("%IM_INSTALL_DIR%\plugins\org.eclipse.equinox.common*.jar") do call :SETCP %%i

:SETCP
set MIG_CP=%MIG_CP%;%*

:end
